SdFat: fat_boot Struct Reference

SdFat

Public Attributes | List of all members
fat_boot Struct Reference

Boot sector for a FAT12/FAT16 volume. More...

`#include <FatStructs.h>`

## Public Attributes
uint8_t | bootCode [448]
uint8_t | bootSectorSig0
uint8_t | bootSectorSig1
uint8_t | bootSignature
uint16_t | bytesPerSector
uint8_t | driveNumber
uint8_t | fatCount
char | fileSystemType [8]
uint16_t | headCount
uint32_t | hidddenSectors
uint8_t | jump [3]
uint8_t | mediaType
char | oemId [8]
uint8_t | reserved1
uint16_t | reservedSectorCount
uint16_t | rootDirEntryCount
uint8_t | sectorsPerCluster
uint16_t | sectorsPerFat16
uint16_t | sectorsPerTrack
uint16_t | totalSectors16
uint32_t | totalSectors32
char | volumeLabel [11]
uint32_t | volumeSerialNumber

## Detailed Description

Boot sector for a FAT12/FAT16 volume.

## Member Data Documentation

## ◆ bootCode

uint8_t fat_boot::bootCode[448]

X86 boot code

## ◆ bootSectorSig0

uint8_t fat_boot::bootSectorSig0

must be 0X55

## ◆ bootSectorSig1

uint8_t fat_boot::bootSectorSig1

must be 0XAA

## ◆ bootSignature

uint8_t fat_boot::bootSignature

0X29 if next three fields are valid

## ◆ bytesPerSector

uint16_t fat_boot::bytesPerSector

The size of a hardware sector. Valid decimal values for this field are 512, 1024, 2048, and 4096. For most disks used in the United States, the value of this field is 512.

## ◆ driveNumber

uint8_t fat_boot::driveNumber

Related to the BIOS physical drive number. Floppy drives are identified as 0x00 and physical hard disks are identified as 0x80, regardless of the number of physical disk drives. Typically, this value is set prior to issuing an INT 13h BIOS call to specify the device to access. The value is only relevant if the device is a boot device.

## ◆ fatCount

uint8_t fat_boot::fatCount

The number of copies of the FAT on the volume. The value of this field is always 2.

## ◆ fileSystemType

char fat_boot::fileSystemType[8]

A field with a value of either FAT, FAT12 or FAT16, depending on the disk format.

## ◆ headCount

uint16_t fat_boot::headCount

Number of heads for interrupt 0x13. Not used otherwise.

## ◆ hidddenSectors

uint32_t fat_boot::hidddenSectors

Count of hidden sectors preceding the partition that contains this FAT volume. This field is generally only relevant for media visible on interrupt 0x13.

## ◆ jump

uint8_t fat_boot::jump[3]

The first three bytes of the boot sector must be valid, executable x 86-based CPU instructions. This includes a jump instruction that skips the next non-executable bytes.

## ◆ mediaType

uint8_t fat_boot::mediaType

This dates back to the old MS-DOS 1.x media determination and is no longer usually used for anything. 0xF8 is the standard value for fixed (non-removable) media. For removable media, 0xF0 is frequently used. Legal values are 0xF0 or 0xF8-0xFF.

## ◆ oemId

char fat_boot::oemId[8]

This is typically a string of characters that identifies the operating system that formatted the volume.

## ◆ reserved1

uint8_t fat_boot::reserved1

used by Windows NT - should be zero for FAT

## ◆ reservedSectorCount

uint16_t fat_boot::reservedSectorCount

The number of sectors preceding the start of the first FAT, including the boot sector. The value of this field is always 1.

## ◆ rootDirEntryCount

uint16_t fat_boot::rootDirEntryCount

For FAT12 and FAT16 volumes, this field contains the count of 32-byte directory entries in the root directory. For FAT32 volumes, this field must be set to 0. For FAT12 and FAT16 volumes, this value should always specify a count that when multiplied by 32 results in a multiple of bytesPerSector. FAT16 volumes should use the value 512.

## ◆ sectorsPerCluster

uint8_t fat_boot::sectorsPerCluster

Number of sectors per allocation unit. This value must be a power of 2 that is greater than 0. The legal values are 1, 2, 4, 8, 16, 32, 64, and 128. 128 should be avoided.

## ◆ sectorsPerFat16

uint16_t fat_boot::sectorsPerFat16

Count of sectors occupied by one FAT on FAT12/FAT16 volumes. On FAT32 volumes this field must be 0, and sectorsPerFat32 contains the FAT size count.

## ◆ sectorsPerTrack

uint16_t fat_boot::sectorsPerTrack

Sectors per track for interrupt 0x13. Not used otherwise.

## ◆ totalSectors16

uint16_t fat_boot::totalSectors16

This field is the old 16-bit total count of sectors on the volume. This count includes the count of all sectors in all four regions of the volume. This field can be 0; if it is 0, then totalSectors32 must be non-zero. For FAT32 volumes, this field must be 0. For FAT12 and FAT16 volumes, this field contains the sector count, and totalSectors32 is 0 if the total sector count fits (is less than 0x10000).

## ◆ totalSectors32

uint32_t fat_boot::totalSectors32

This field is the new 32-bit total count of sectors on the volume. This count includes the count of all sectors in all four regions of the volume. This field can be 0; if it is 0, then totalSectors16 must be non-zero.

## ◆ volumeLabel

char fat_boot::volumeLabel[11]

A field once used to store the volume label. The volume label is now stored as a special file in the root directory.

## ◆ volumeSerialNumber

uint32_t fat_boot::volumeSerialNumber

A random serial number created when formatting a disk, which helps to distinguish between disks. Usually generated by combining date and time.

The documentation for this struct was generated from the following file:

- Arduino/libraries/SdFat/src/FatLib/FatStructs.h